javax.enterprise.inject.spi

## Interface ProcessObserverMethod<T,X>

- Type Parameters:
    `T` - The type of the event being observed
    `X` - The bean type containing the observer method

      public interface ProcessObserverMethod<T,X>

  The container fires an event of this type for each observer method of each enabled bean, before registering the `ObserverMethod` object.

  If any observer method of a `ProcessObserverMethod` event throws an exception, the exception is treated as a definition error by the container.

  Author:
    Gavin King, David Allen
  See Also:
    `ObserverMethod`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDefinitionError(Throwable t)` Registers a definition error with the container, causing the container to abort deployment after bean discovery is complete.
    `AnnotatedMethod<X>` | `getAnnotatedMethod()` The `AnnotatedMethod` representing the observer method.
    `ObserverMethod<T>` | `getObserverMethod()` The `ObserverMethod` object that will be used by the container to invoke the observer when a matching event is fired.

- - ### Method Detail

    - #### getAnnotatedMethod

          AnnotatedMethod<X> getAnnotatedMethod()

      The `AnnotatedMethod` representing the observer method.
      Returns:
        the `AnnotatedMethod` representing the observer method
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

    - #### getObserverMethod

          ObserverMethod<T> getObserverMethod()

      The `ObserverMethod` object that will be used by the container to invoke the observer when a matching event is fired.
      Returns:
        the `ObserverMethod` object that will be used by the container to call the observer method
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

    - #### addDefinitionError

          void addDefinitionError(Throwable t)

      Registers a definition error with the container, causing the container to abort deployment after bean discovery is complete.
      Parameters:
        `t` - A `Throwable` representing the definition error
      Throws:
        `IllegalStateException` - if called outside of the observer method invocation

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.